unit Regdlg;

interface

uses WinTypes, winprocs, Classes, Graphics, Extctrls, controls, DsgnIntf, dialogs, forms,
     Areg, inifiles, toreg, SYSUTILS;

type
  TShowtime = (StStart, StStartAndEnd);
  TReg = class(TComponent)
    private
      { Private fields of Treg }
        KEY, EKEY : string;
        Password : Integer;
        Fshowtime : TShowtime;
        Fday : integer;
      { Private methods of Treg }
      procedure setuser(value:string);
      procedure setversion(value: string);
    protected
        constructor Create(AOwner: TComponent); override;
        destructor destroy ; override;
        procedure loaded; override;
    public
      { Public fields of Treg }
      days : integer;
    published
      { Published properties of the component }
      property UserName : string read key write setuser;
      Property Version : string read EKEY write setversion;
      property Confirm : TShowtime read Fshowtime write Fshowtime;
      Property DaysExpire: integer read fday write Fday default 0;
  end;

procedure Register;

implementation

Function get_key(day:integer): string;
 Var
  RegAsk: TRegAsk;
 begin
  try
   RegAsk:=TRegAsk.Create(Application);
   RegAsk.expire := day;
   RegAsk.caption := Application.title;
   RegAsk.showmodal;
   result := RegAsk.caption;
  finally
   Regask.Free;
  end;
End;

procedure Register;
begin
    RegisterComponents('Mik', [Treg]);
end;

procedure Treg.setuser(value:string);
Begin
 key := value;
 user := value;
end;

procedure Treg.setversion(value: string);
Begin
 ekey := value;
 ver := value;
end;

procedure Treg.loaded;
Begin
 inherited loaded;
 user := key;
 ver := ekey;
 if not (csDesigning in ComponentState) then
  with TInifile.create('Registry.ini') do
   Begin
    password := readinteger('Registry',Application.title,0);
    user := readstring('Registry','username',key);
    ver  := readstring('Registry','version',ekey);
    key := user;
    days := fday;
    If fday > 1 then
      days:= readinteger('Registry','RegisterDate',fday - 1);
    Free;
   End;
 make_password(key,ekey);
 days := days - sum_str(vivid);
 if days > 0 then
  Fday := days;
 if not (csDesigning in ComponentState) then
 if (password = 0) or (password <> Sum_str(VIVID) + SUM_STR(USER) + SUM_STR(VER)) then
    get_key(fday);
end;

destructor Treg.destroy ;
Begin
if not (csDesigning in ComponentState) then
  with TInifile.create('Registry.ini') do
   Begin                                       
    password := readinteger('Registry',Application.title,0);
    make_password(key,ekey);
    if (password = 0) or (password <> Sum_str(VIVID) + SUM_STR(USER) + SUM_STR(VER)) then
    Begin
      if Fshowtime = StStartandend then
        get_key(fday);
      if fday > 1 then
       begin
         if datetostr(date) <> readstring('Registry','Control','') then
         Begin
          writeinteger('Registry','RegisterDate',sum_str(vivid) + fday -1 );
          writestring('Registry','Control',datetostr(date));
         end;
       end;
    end;
    free;
   end;
  inherited destroy;
End;

constructor Treg.Create;
begin
  inherited Create(AOwner);
  key := 'A company';
  Ekey:= 'version 1.01.01';
end;

BEGIN
 randomize;
end.
